<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: AddToPostCount.php
//      Item

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: IncreaseTimeLoggedIn.php 24 2006-10-21 03:34:18Z daniel15 $

class item_IncreaseTimeLoggedIn extends itemTemplate {
    function getItemDetails() {
		$this->authorName = "Daniel15";
		$this->authorWeb = "http://www.dansoftaustralia.net/";
		$this->authorEmail = "dansoft@dansoftaustralia.net";

        $this->name = "Increase Total Time by xxx";
        $this->desc = "Increase your total time logged in by xxx (default is 12 hours)";
        $this->price = 50;
        
        $this->require_input = false;
        $this->can_use_item = true;
    }
    
    function getAddInput() {
        return "Amount to increase total time by (in seconds): <input type='text' name='info1' value='43200' />";
    }

    function getUseInput() {
        return "";
    }

    function onUse() {
        global $db_prefix, $ID_MEMBER, $item_info;

        $result = db_query("UPDATE {$db_prefix}members
                            SET totalTimeLoggedIn = totalTimeLoggedIn + {$item_info[1]}
                            WHERE ID_MEMBER = {$ID_MEMBER}",
                            __FILE__, __LINE__);

        $time_hours = $item_info[1] / 3600;
        return "Successfully added {$item_info[1]} seconds ({$time_hours} hours) to total logged in time.";
    }

}

?>
