<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: Rock.php
//      Rock Item (does nothing)

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Rock.php 24 2006-10-21 03:34:18Z daniel15 $

// Your class should always be called item_filename, eg. if your file is 
// myCoolItem.php then the class should be called 'item_myCoolItem'. This 
// class should always extend itemTemplate.
class item_rock extends itemTemplate {
    
    // When this function is called, you should set all the item's
    // variables (see inside this example)
    function getItemDetails() {

		// The author of the item
		$this->authorName = "Daniel15";
		// The author's website
		$this->authorWeb = "http://www.dansoftaustralia.net/";
		// And their email address
		$this->authorEmail = "dansoft@dansoftaustralia.net";


        // VALUES CHANGEABLE FROM WITHIN ADMIN PANEL:
          // The name of the item
          $this->name = "Rock";
          // The item's description
          $this->desc = "Well.... It does nothing";
          // The item's price
          $this->price = 5;
          
        //UNCHANGEABLE VALUES:
          // Whether the item requires input or not. In this case, we don't need
          // any input
          $this->require_input = false;
          // Since this is a rock (you can't use it), we set this to false
          $this->can_use_item = false;
    }

    // Since this item requires no input, we don't need to have a getUseInput function
    // here (see the testitem2.php file if you want to make an item that needs input)

    // Also, since this is a rock, you don't need an onUse function (since it doesn't get used)
}
?>
