<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Bank.php
//      Bank stuff (view bank, deposit, withdraw)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop-Bank.php 24 2006-10-21 03:34:18Z daniel15 $

// If the file isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// If we're in the bank
if ($_GET['do'] == "bank") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=bank",
		'name' => $txt['shop_bank'],
	);
	
	// Get money in bank
	$result = db_query("SELECT moneyBank, money
						FROM {$db_prefix}members
						WHERE ID_MEMBER = $ID_MEMBER
						LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	
	// Set the shop bank message
	$context['shop_bank_message'] = sprintf($txt['shop_current_bank'], formatMoney($row['moneyBank']), formatMoney($row['money']));
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_bank'];
	// Load the 'bank' sub template
	$context['sub_template'] = "bank";
	loadTemplate('Shop');

// If they've submitted something on the bank page
} elseif($_GET['do'] == "bank2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=bank",
		'name' => $txt['shop_bank'],
	);
	
	// If they're depositing some money
	if ($_POST['type'] == "deposit") {
		// Make sure the amount of money is numeric
		$_POST['amount'] = (float) $_POST['amount'];
		// Get user's money
		$result = db_query("SELECT money
							FROM {$db_prefix}members
							WHERE ID_MEMBER = $ID_MEMBER
							LIMIT 1", __FILE__, __LINE__);

		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		// If user is trying to deposit more money than they have
		if ($_POST['amount'] > $row['money']) {
			$context['shop_buy_message'] = $txt['shop_dont_have_much'];
		// If they're trying to deposit less than 0
		} elseif ($_POST['amount'] <= 0) {
			$context['shop_buy_message'] = $txt['shop_no_negative'];
		// If the amount they're transferring is less than the minimum
		} elseif ($_POST['amount'] < $modSettings['shopMinDeposit']) {
			$context['shop_buy_message'] = sprintf($txt['shop_deposit_small'], formatMoney($modSettings['shopMinDeposit']));
		// All is good :-)
		} else {
			// Add amount to member's bank money, and remove from money in pockey
			$result = db_query("UPDATE {$db_prefix}members
								SET moneyBank = moneyBank + {$_POST['amount']},
									money = money - {$_POST['amount']}
								WHERE ID_MEMBER = $ID_MEMBER
								LIMIT 1", __FILE__, __LINE__);

			// Get new money amounts (pocket and bank)
			$result = db_query("SELECT money, moneyBank
								FROM {$db_prefix}members
								WHERE ID_MEMBER = $ID_MEMBER
								LIMIT 1", __FILE__, __LINE__ );
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
			
			// Format the amounts
			$money = formatMoney($row['money']);
			$moneyBank = formatMoney($row['moneyBank']);
			// Set the message to show them
			$context['shop_buy_message'] = sprintf($txt['shop_deposit'], $moneyBank, $money)."<br /><a href='$scripturl?action=shop;do=bank'>{$txt['shop_back2bank']}</a>";
		}
	// If they're withdrawing some money
	} elseif ($_POST['type'] == "withdraw") {
		// Make sure amount is numeric
		$_POST['amount'] = (float) $_POST['amount'];
		// Get user's money in bank
		$result = db_query("SELECT moneyBank
							FROM {$db_prefix}members
							WHERE ID_MEMBER = $ID_MEMBER
							LIMIT 1", __FILE__, __LINE__);

		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		// If user is trying to withdraw more money than they have
		if ($_POST['amount'] > $row['moneyBank']) {
			$context['shop_buy_message'] = $txt['shop_dont_have_much2'];
		// If they're trying to take out less than 0
		} elseif ($_POST['amount'] <= 0) {
			$context['shop_buy_message'] = $txt['shop_no_negative'];
		// If the amount they specified is less than the minimum
		} elseif ($_POST['amount'] < $modSettings['shopMinWithdraw']) {
			$context['shop_buy_message'] = sprintf($txt['shop_withdraw_small'], formatMoney($modSettings['shopMinWithdraw']));
		// All is good
		} else {
			// Remove amount from member's bank money, and add to money in pockey
			$result = db_query("UPDATE {$db_prefix}members
								SET moneyBank = moneyBank - {$_POST['amount']},
									money = money + {$_POST['amount']}
								WHERE ID_MEMBER = $ID_MEMBER
								LIMIT 1", __FILE__, __LINE__);
								
			// Get current money amounts (pocket and bank)
			$result = db_query("SELECT money, moneyBank
								FROM {$db_prefix}members
								WHERE ID_MEMBER = $ID_MEMBER
								LIMIT 1", __FILE__, __LINE__ );
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
			
			// Format the amounts
			$money = formatMoney($row['money']);
			$moneyBank = formatMoney($row['moneyBank']);
			// Show them the success message
			$context['shop_buy_message'] = sprintf($txt['shop_withdraw'], $money, $moneyBank)."<br /><a href='$scripturl?action=shop;do=bank'>{$txt['shop_back2bank']}</a>";
		}
	} else {
	   die('ERROR: The type passed was not valid!');
	}
	
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_bank'];
	// Use the 'message' template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
}
?>
