<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Buy.php
//      Used when buying something from the shop.
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop-Buy.php 24 2006-10-21 03:34:18Z daniel15 $

// If this script isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');
	
// If they're buying something	
if ($_GET['do'] == "buy") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=buy",
		'name' => $txt['shop_buy'],
	);
	
	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort'])) $_GET['sort'] = "0";
	if (!isset($_GET['sortDir'])) $_GET['sortDir'] = "0";
	
	// Get the sort type
	switch($_GET['sort']) {
		case 0:
			$sortType = $txt['shop_name'];
			$sortQuery = "name";
			break;
		case 1:
			$sortType = $txt['shop_price'];
			$sortQuery = "price";
			break;
		case 2:
			$sortType = $txt['shop_description'];
			$sortQuery = "`desc`";
			break;
		case 3:
			$sortType = $txt['shop_stock'];
			$sortQuery = "stock";
			break;
		default:
			die("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir']) {
		case 0:
			$sortDirType = $txt['shop_asc'];
			$sortDirQuery = "ASC";
			break;
		case 1:
			$sortDirType = $txt['shop_desc'];
			$sortDirQuery = "DESC";
			break;	
		default:
			die("Invalid sort method passed");
			break;
	}	
	
	// Start the item list
	$context['shop_items_list'] = "
<tr>
	<td align='right' colspan='4'>
		<form action='$scripturl' method='get'>
			".sprintf($txt['shop_sort'], $sortType, $sortDirType)."
			<input type='hidden' name='action' value='shop' />
			<input type='hidden' name='do' value='buy' />
			<select name='sort'>
				<option value='0'>{$txt['shop_name']}</option>
				<option value='1'>{$txt['shop_price']}</option>
				<option value='2'>{$txt['shop_description']}</option>
				<option value='3'>{$txt['shop_stock']}</option>
			</select>
			
			<select name='sortDir'>
				<option value='0'>{$txt['shop_asc']}</option>
				<option value='1'>{$txt['shop_desc']}</option>
			</select>
			
			<input type='submit' value='Go' />
		</form>
	</td>
</tr>

<tr valign='top' class='windowbg'>
	<td style='padding-bottom: 2ex;' width='32'>
		<b>{$txt['shop_image']}</b>
	</td>
	<td>
		<b>{$txt['shop_name']}</b>
	</td>
	<td>
		<b>{$txt['shop_description']}</b>
	</td>
	<td width='18%'>
		<b>{$txt['shop_price']}/{$txt['shop_stock']}</b>
	</td>
</tr>";

	// Get the amount of money the user has
	$result = db_query("SELECT money
						FROM {$db_prefix}members
						WHERE ID_MEMBER = $ID_MEMBER
						LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = (float) $row['money'];

	$alternating = "windowbg2";
	$itemRows = array();
	
	// Get all the items available
	$result = db_query("SELECT name, `desc`, price, stock, id, image
						FROM {$db_prefix}shop_items
						ORDER BY {$sortQuery} {$sortDirQuery}", __FILE__, __LINE__);

	// Loop through all the items...
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
		//... and add them to the list
		$itemRows[] = $row;

	// If the page is not set, assume page 1
	if (!isset($_GET['page'])) $_GET['page'] = 1;
	// If items per page not set, assume 15
	if (!isset($modSettings['shopItemsPerPage'])) $modSettings['shopItemsPerPage'] = 15;
	
	// The page count - Total number of items divided by number per page
	$pageCount = ceil(count($itemRows) / $modSettings['shopItemsPerPage']);
	// First item
	$firstItem = ($_GET['page'] * $modSettings['shopItemsPerPage']) - $modSettings['shopItemsPerPage'];
	
	// Loop through all items on this page
	for ($x = $firstItem; ($x < $firstItem + $modSettings['shopItemsPerPage']) && ($x < count($itemRows)) ; $x++) {
		// Add to the list
		$context['shop_items_list'] .= "
<tr valign='top' class='{$alternating}'>
	<td>
		<img border='0' width='{$modSettings['shopImageWidth']}' height='{$modSettings['shopImageHeight']}' src='{$boardurl}/Sources/shop/item_images/{$itemRows[$x]['image']}' alt='Item Image' />
	</td>
	<td style='padding-bottom: 2ex;' width='20%'>
		{$itemRows[$x]['name']}
	</td>
	<td>
		{$itemRows[$x]['desc']}
	</td>
	<td width='18%'>
		{$txt['shop_price']}: {$itemRows[$x]['price']}<br />
		{$txt['shop_stock']}: {$itemRows[$x]['stock']}<br />";
		
		// If the item is out of stock
		if ($itemRows[$x]['stock'] == 0) {
			$context['shop_items_list'] .= "<b>{$txt['shop_soldout']}</b>";
		// If the user doesn't have enough money
		} elseif ($usersmoney < $itemRows[$x]['price']) {
			$context['shop_items_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($itemRows[$x]['price'] - $usersmoney))."</b>";
		// If they have enough money, and can buy it
		} else {
			$context['shop_items_list'] .= "<a href='$scripturl?action=shop;do=buy2;id={$itemRows[$x]['id']}'>{$txt['shop_buynow']}</a>";
		}

		// Add the 'Who Owns This' link
		$context['shop_items_list'] .= "
		<br /><a href='$scripturl?action=shop;do=owners;id={$itemRows[$x]['id']}'>{$txt['shop_owners']}</a>
</td></tr>";

		// Alternating row background
		$alternating = ($alternating == "windowbg") ? 'windowbg2' : 'windowbg';
	} 
	
	// Miscellaneous stuff
	$context['shop_pages'] = $pageCount;
	$context['shop_current_page'] = $_GET['page'];
	$context['shop_page_link'] = $scripturl."?action=shop;do=buy;sort=".$_GET['sort'].";sortDir=".$_GET['sortDir'];
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_buy'];
	// Use 'Inventory' template
	$context['sub_template'] = "inventory";
	// Load the template
	loadTemplate('Shop');
	
// If they're buying an item
} elseif ($_GET['do'] == "buy2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=buy",
		'name' => $txt['shop_buy'],
	);

	// Make sure the item ID is numeric
	$_GET['id'] = (int) $_GET['id'];

	// User's money
	$result = db_query("SELECT money
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = $row['money'];

	// Item information
	$result = db_query("SELECT price, stock, name
						FROM {$db_prefix}shop_items
						WHERE id = {$_GET['id']}
						LIMIT 1", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);

	// If they don't have enough money
	if ($usersmoney < $row['price']) {
		$context['shop_buy_message'] = sprintf($txt['shop_need'], formatMoney($row['price'] - $usersmoney));
	// If there's no stock left
	} elseif ($row['stock'] == 0) {
		$context['shop_buy_message'] = $txt['shop_soldout_full'];
	// All is well, they can buy it :)
	} else {
		// Put item in user's inventory
		$result = db_query("INSERT
							INTO {$db_prefix}shop_inventory
							(ownerid, itemid, amtpaid)
							VALUES (
									{$ID_MEMBER},
									{$_GET['id']},
									{$row['price']})",
									__FILE__, __LINE__);

		// Decrease user's money
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money - {$row['price']}
							WHERE ID_MEMBER = {$ID_MEMBER}
							LIMIT 1",
							__FILE__, __LINE__);

		// Decrease stock by 1
		$result = db_query("UPDATE {$db_prefix}shop_items
							SET stock = stock - 1
							WHERE id = {$_GET['id']}
							LIMIT 1",
							__FILE__, __LINE__);

		// Tell them that they purchased it
		$context['shop_buy_message'] = sprintf($txt['shop_bought_item'], $row['name']);
	}

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_buy'];	
	// Use the 'message' template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
}
?>
