<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Send.php
//      Various sending stuff (Send money to other person, send item to other person)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop-Send.php 24 2006-10-21 03:34:18Z daniel15 $

// If this script isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

if ($_GET['do'] == "sendmoney") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=sendmoney",
		'name' => $txt['shop_send_money'],
	);
	
	// If $_GET['member'] is set, pass it to the page. Otherwise, set it to blank.
	$context['shopSendMoneyMember'] = isset($_GET['member']) ?  $_GET['member'] : '';

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_send_money'];
	// Use the sendmoney template
	$context['sub_template'] = "sendmoney";
	loadTemplate('Shop');
	
// If they've submitted the form - Actually send the money
} elseif($_GET['do'] == "sendmoney2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=sendmoney",
		'name' => $txt['shop_send_money'],
	);

	// Make sure amount is numeric
	$amount = (float) $_POST['amount'];

	// Get the current member's money count
	$result = db_query("SELECT money, memberName, realName
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$membersUserName = $row['memberName'];
	$membersName = $row['realName'];

	// Trying to give more than they have
	if ($row['money'] < $amount) { 
		$context['shop_buy_message'] = $txt['shop_dont_have_much'];
	// Trying to *give* a negative amount? Nice try...
	} elseif ($amount < 0) { 
		$context['shop_buy_message'] = $txt['shop_give_negative'];
	// Giving 0 credits...? What's the point?
	} elseif ($amount == 0) {
		$context['shop_buy_message'] = $txt['shop_invalid_send_amount'];
	} else {
		// Get the id and name of member to send to
		$result = db_query("SELECT ID_MEMBER, memberName
							FROM {$db_prefix}members
							WHERE memberName = '{$_POST['membername']}'
							LIMIT 1", __FILE__, __LINE__);
		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		
		// If the member's name is not what the user posted... They don't exist!
		if ($row['memberName'] !== $_POST['membername']) {
			$context['shop_buy_message'] = sprintf($txt['shop_member_no_exist'], $_POST['membername']);
		} else {
			// Take money off sender
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money - {$amount}
								WHERE ID_MEMBER = {$ID_MEMBER}
								LIMIT 1", __FILE__, __LINE__);

			// Give money to receiver
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money + {$amount}
								WHERE ID_MEMBER = {$row['ID_MEMBER']}
								LIMIT 1", __FILE__, __LINE__);
								
			// Who the IM will come from		 
			$pmfrom = array(
				'id' => $ID_MEMBER,
				'name' => $membersName,
				'username' => $membersUserName
			);
		
			// Who the IM is going to
			$pmto = array(
				'to' => array($row['ID_MEMBER']),
				'bcc' => array()
			);
		
			// The subject of the message
			$subject = sprintf($txt['shop_im_sendmoney_subject'], formatMoney($amount), $membersName);
			// The actual message contents
			$message = sprintf($txt['shop_im_sendmoney_message'], $membersName, formatMoney($amount), $_POST['message']);
			// Now, send!
			sendpm($pmto, $subject, $message, 0, $pmfrom);

			// Tell the user that their request was successful
			$context['shop_buy_message'] = sprintf($txt['shop_successfull_send'], formatMoney($amount), $row['memberName']);
		}
	}
	
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_send_money'];
	// Use the 'message' template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	
// Send an item to someone
} elseif($_GET['do'] == "senditems") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=senditems",
		'name' => $txt['shop_send_item'],
	);
	
	// Start with a blank list
	$context['shop_send_items'] = "";
	
	// Get all the user's current items
	$result = db_query("SELECT it.name, inv.id AS ivid, inv.trading
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.ownerid = {$ID_MEMBER} AND inv.itemid = it.id AND inv.trading = 0
						GROUP BY it.id
						ORDER BY it.name ASC ", __FILE__, __LINE__);				
	// Loop through all the items...
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
		// ...and add them to the list
		$context['shop_send_items'] .= "<option value='{$row['ivid']}'>{$row['name']}</option>";

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_send_item'];
	// Use the 'send items' template
	$context['sub_template'] = "sendItems";
	loadTemplate('Shop');
	
// Send an item to someone - Actual send
} elseif($_GET['do'] == "senditems2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=senditems2",
		'name' => $txt['shop_send_money'],
	);

	// Make sure the ID was numeric
	$_POST['giftid'] = (int) $_POST['giftid'];
	
	// Current item information
	$result = db_query("SELECT inv.ownerid, inv.itemid, it.name
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = '{$_POST['giftid']}' AND it.id = inv.itemid", __FILE__, __LINE__);
	$rowItem = mysql_fetch_array($result, MYSQL_ASSOC);
	
	// You don't add the item? Sorry, but we don't allow stealing! :D
	if ($rowItem['ownerid'] !== $ID_MEMBER) die($txt['shop_use_others_item']);
   
	// Get new owner's information
	$result = db_query("SELECT ID_MEMBER
						FROM {$db_prefix}members
						WHERE memberName = '{$_POST['membername']}'", __FILE__, __LINE__);
	$rowNewOwner = mysql_fetch_array($result, MYSQL_ASSOC);
   
	// Get current owner's name (current user)
	$result = db_query("SELECT memberName, realName
					FROM {$db_prefix}members
					WHERE ID_MEMBER = {$ID_MEMBER}", __FILE__, __LINE__);
	$rowCurrOwner = mysql_fetch_array($result, MYSQL_ASSOC);
	
	$membersUserName = $rowCurrOwner['memberName'];
	$membersName = $rowCurrOwner['realName'];
	
   // Set the new owner
	$result = db_query("UPDATE {$db_prefix}shop_inventory
					SET ownerid = {$rowNewOwner['ID_MEMBER']}
					WHERE id = {$_POST['giftid']}", __FILE__, __LINE__);
	
	// The sender of the IM
	$pmfrom = array(
		'id' => $ID_MEMBER,
		'name' => $membersName,
		'username' => $membersUserName
	);

	// The receiver of the IM
	$pmto = array(
		'to' => array($rowNewOwner['ID_MEMBER']),	
		'bcc' => array()
			);
			
	// The message subject
	$subject = $txt['shop_im_senditem_subject'];
	// The actual message
	$message = sprintf($txt['shop_im_senditem_message'], $membersName, $rowItem['name'], $_POST['message']);
	// Send the IM :)
	sendpm($pmto, $subject, $message, 0, $pmfrom);

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_send_item'];
	// Use the 'message' template
	$context['sub_template'] = "message";
	// And show the 'success' message :)
	$context['shop_buy_message'] = $txt['shop_transfer_success'];
	loadTemplate('Shop');	
}	
?>
