<?php

/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: testitem.php
//      Test Item (gets some inputs, most likely you will base your items on this)

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: StickyTopic.php 24 2006-10-21 03:34:18Z daniel15 $

class item_StickyTopic extends itemTemplate {
 
    function getItemDetails() {
		$this->authorName = "Daniel15";
		$this->authorWeb = "http://www.dansoftaustralia.net/";
		$this->authorEmail = "dansoft@dansoftaustralia.net";

          $this->name = "Sticky Topic";
          $this->desc = "Make any one of your topics a sticky!";
          $this->price = 400;

          $this->require_input = true;
          $this->can_use_item = true;
    }

    function getUseInput() {
		global $db_prefix, $ID_MEMBER;
		
		$returnStr = "
			Please choose which topic you would like to sticky: <br />
			<select name='stickyTopic'>";

		$result = db_query("SELECT t.ID_TOPIC, t.isSticky, m.subject
							 FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m
							 WHERE t.ID_MEMBER_STARTED = {$ID_MEMBER} AND m.ID_MSG = t.ID_FIRST_MSG", __FILE__, __LINE__);		
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			if ($row['isSticky'] == 0) {
				$returnStr .= "<option value='{$row['ID_TOPIC']}'>{$row['subject']}</option>";
			}
		}
		
		$returnStr .= "</select>";
        return $returnStr;
    }

    function onUse() {
		global $db_prefix, $ID_MEMBER;
		
		if (!isset($_POST['stickyTopic'])) die("ERROR: No topic chosen!");
		$_POST['stickyTopic'] = (int) $_POST['stickyTopic'];
		
		$result = db_query("SELECT isSticky, ID_MEMBER_STARTED
							 FROM {$db_prefix}topics
							 WHERE ID_TOPIC = {$_POST['stickyTopic']}", __FILE__, __LINE__);
		$row = mysql_fetch_array($result, MYSQL_ASSOC);		
		
		if (mysql_num_rows($result) == 0)  die("ERROR: That topic does not exist!");
		if ($row['ID_MEMBER_STARTED'] != $ID_MEMBER) die ("ERROR: That isn't your topic!");
		
		db_query("UPDATE {$db_prefix}topics			 
					SET isSticky = 1
					WHERE ID_TOPIC = {$_POST['stickyTopic']}
					LIMIT 1", __FILE__, __LINE__);
							 
        return "Made topic #{$_POST['stickyTopic']} a sticky!";
    }
}

?>
