<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: ShopAdmin.template.php
//	  Template file for Shop Administration

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: ShopAdmin.template.php 24 2006-10-21 03:34:18Z daniel15 $

// Feel free to edit this template however you want, but be careful not to break anything.
// Make sure you have a backup handy.

// The main admin page
function template_main(){
	global $modSettings, $scripturl, $context, $txt, $sourcedir;
	
	// Get the SMFShop version information (file only loaded if not loaded previously)
	require_once("{$sourcedir}/shop/shopVersion.php");

	echo '
	  <form action="', $scripturl, '?action=shop_general;step=1" method="POST">
		<table width="100%" cellpadding="0" cellspacing="0" border="0" style="margin-top: 1.5ex;">
		 <tr>
			<td valign="top"  colspan="3">
				<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor">
					<tr>
						<td class="catbg">', $txt['shop_version_info_header'], '</td>
					</tr><tr>
						<td class="windowbg2" valign="top" style="height: 18ex;" align="center">
							<b>', $txt['shop_version_info_header'], ':</b><br />
							', $txt['shop_version_number'], ': <span id="yourShopVersion">', $shopVersion['version'], '</span> (Build <span id="yourShopBuild">', $shopVersion['build'], ')</span><br />
							', $txt['shop_database_version'], ': ', $modSettings['shopVersion'], ' (Build ', $modSettings['shopBuild'], ')<br />
							', $txt['shop_version_reldate'], ': ', $shopVersion['date'], '<br /><br />';

	if ($shopVersion['develVersion'] == true) {
		echo '
							<b>This is a development version of SMFShop!</b><br />
							SVN ID: ', $shopVersion['SVNid'], '<br />
							SVN Date: ', $shopVersion['SVNdate'], '<br />';
	}
	
	echo '
								<br />
							<span id="currShopVersion">', $txt['shop_unable_connect'], '</span>
						</td>
					</tr>
				</table>
			</td>
			</tr>
			<tr><td style="width: 1ex;">&nbsp;</td></tr>
			<tr>
			 <td valign="top" style="width: 50%;">
				<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor" id="supportVersionsTable">
					<tr>
						<td class="catbg">', $txt['shop_settings_general'], '</td>
					</tr><tr>
						<td class="windowbg2" valign="top" style="height: 18ex;">
								', $txt['shop_itemsperpage'], ': <input type="text" name="itemspage" value="', $modSettings['shopItemsPerPage'], '" size="5" /><br />
								 <input type="checkbox" name="tradeenabled" value="yeah"', $context['shop_trade'], ' />', $txt['shop_trade_enable'], '<br /><hr />
								<input type="checkbox" name="bankenabled" value="yeah"', $context['shop_bank'], ' />', $txt['shop_bank'], ' Enabled<br />
								', $txt['shop_bankinterest'], ': <input type="text" name="interest" value="', $modSettings['shopInterest'], '" size="3" />% per day<br />
								', $txt['shop_bank_minDeposit'], ': ', $modSettings['shopCurrencyPrefix'], '<input type="text" name="minDeposit" value="', $modSettings['shopMinDeposit'], '" size="3" />', $modSettings['shopCurrencySuffix'], '<br />
								', $txt['shop_bank_minWithdraw'], ': ', $modSettings['shopCurrencyPrefix'], '<input type="text" name="minWithdraw" value="', $modSettings['shopMinWithdraw'], '" size="3" />', $modSettings['shopCurrencySuffix'], '<br />
								', $txt['shop_bank_disableMin'], '
								<hr />
								', $txt['shop_image_width'], ': <input type="text" name="image_width" value="', $modSettings['shopImageWidth'], '" size="3" /><br />
								', $txt['shop_image_height'], ': <input type="text" name="image_height" value="', $modSettings['shopImageHeight'], '" size="3" /><br /><br />
								<input type="submit" value="', $txt['shop_save_changes'], '" /><br />
								<b>', $context['shop_general'], '</b>
						</td>
					</tr>
				</table>
			</td>

			<td style="width: 1ex;">&nbsp;</td>
			<td valign="top" style="width: 50%;">
				<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor" id="supportVersionsTable">
					<tr>
						<td class="catbg">', $txt['shop_settings_currency'], '</td>
					</tr><tr>
						<td class="windowbg2" valign="top" style="height: 18ex;">
								', $txt['shop_currency_prefix'], ': <input type="text" name="prefix" value="', $modSettings['shopCurrencyPrefix'], '" size="5" /><br />
								', $txt['shop_currency_suffix'], ': <input type="text" name="suffix" value="', $modSettings['shopCurrencySuffix'], '" size="5" /><br />

								', $txt['shop_pre-suf_confuse'], '<br /><br />
								', $txt['shop_per_new_topic'], ': <input type="text" name="pertopic" value="', $modSettings['shopPointsPerTopic'], '" size="5" /><br />
								', $txt['shop_per_new_post'], ': <input type="text" name="perpost" value="', $modSettings['shopPointsPerPost'], '" size="5" /><br /><br />

								', $txt['shop_reg_bonus'], ': <input type="text" name="regamount" value="', $modSettings['shopRegAmount'], '" size="5" /><br /><br />								
								
								<input type="submit" value="', $txt['shop_save_changes'], '" /><br />
								<b>', $context['shop_general'], '</b>
						</td>
					</tr>
				</table>
			</td>

		</tr></table>
	   </form>
<br />
New releases can always be found at the <a href="http://www.dansoftaustralia.net/">DanSoft Australia Website</a>';

	if ($shopVersion['develVersion'] == false) {
		echo "<script language='JavaScript' src='http://updates.dansoftaustralia.net/shop-version.js?build={$modSettings['shopBuild']}'></script>";
	} else {
		echo "<script language='JavaScript' type='text/javascript'>
				var currShopVerStr = document.getElementById('currShopVersion');
				setInnerHTML(currShopVerStr, 'Hey, why are you running a development version? Check the DanSoft Australia website for the latest version!');
			  </script>";
	}
}

// Member's Inventory
function template_inventory() {
	global $modSettings, $scripturl, $context, $txt, $settings;

echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="100%">
					<div align="center"><b>', $txt['shop_edit_inventory'], '</b></div>';

	// The 'Please Type a Members Name' page
	if (empty($_GET['do']) || $_GET['do'] == "") {
		echo '
					', $txt['shop_edit_member_inventory'], '<br />
					<form action="', $scripturl, '?action=shop_inventory;do=viewmember" method="post">
						<input name="searchfor" type="text" size="70" />
						<a href="', $scripturl, '?action=findmember;input=searchfor;quote=1;sesc=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img src="', $settings['images_url'], '/icons/assist.gif" border="0" alt="', $txt['find_members'], '" /> Find Members</a><br />
						<input type="submit" value="', $txt['shop_next'], '" />
					</form>';

	// The Inventory list
	} else {
		// If we need to show a message
		if (isset($context['shop_message'])) echo '<div style="color: red; font-weight: bold;">', $context['shop_message'], '</div>'; 

		echo "<i>{$context['shop_inv_message']}</i><br /><br />{$context['shop_inventory_list']}";
	}
	// Close the table
	echo "</td></tr></table>";
}

// Add an item to the shop
function template_items_add() {
	global $context, $scripturl, $txt, $boardurl, $modSettings;

	echo '
<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
	<tr valign="top" class="windowbg2">
		<td style="padding-bottom: 2ex;" width="100%">
			<div align="center"><b>', $txt['shop_add_item'], '</b></div>';

	// Step 1 - Choose Item
	if (empty($_GET['step']) || $_GET['step'] == 0) {
		// How did you get here? You _should_ be at the 'Edit Items' page
		// Oh well, tell them where this has moved
		echo 'This has moved to the Edit Items section. Please go there instead :-)';

	// Step 2 - Settings for the item
	} elseif ($_GET['step'] == 1) {
		// The 'adding an item' notice
		printf($txt['shop_add_item_message2'], $context['shop_items_item']['name'], $context['shop_items_item']['authorName'], $context['shop_items_item']['authorEmail'],  $context['shop_items_item']['authorWeb']);
		echo'
			<br /><br />', $txt['shop_item_configure'], '<br />
			<form action="', $scripturl, '?action=shop_items_add;step=2" method="post" name="theAdminForm">
				<input type="hidden" name="item" value="', $context['shop_items_item']['name'], '" />
				<input type="hidden" name="require_input" value="', $context['shop_items_item']['require_input'], '" />
				<input type="hidden" name="can_use_item" value="', $context['shop_items_item']['can_use_item'], '" />
				', $txt['shop_name'], ': <input name="itemname" type="text" value="', $context['shop_items_item']['friendlyname'], '" size="80" /><br />
				', $txt['shop_description'], ': <textarea name="itemdesc" cols="40" rows="6">', $context['shop_items_item']['desc'], '</textarea><br />
				', $txt['shop_price'], ': <input name="itemprice" type="text" value="', $context['shop_items_item']['price'], '" size="5" /><br />
				', $txt['shop_stock'], ': <input name="itemstock" type="text" value="', $context['shop_items_item']['stock'], '" size="5" /><br /><br />';

		// Show the Select Image dropdown
		echoSelectImage("blank.gif");
		echo '
				<br />', $context['shop_items_item']['getAddInput'], '<br />
				<input type="submit" value="', $txt['shop_add_item'], '" /></form>';
	}

	// Close the table
	echo "</td></tr></table>";
}

// The 'Edit an Item' template
function template_items_edit() { 
	global $context, $scripturl, $txt, $modSettings;

	echo '
<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
	<tr valign="top" class="windowbg2">
		<td style="padding-bottom: 2ex;" width="100%">
			<div align="center"><b>', $txt['shop_admin_items_addedit'], '</b></div>';

	// Editing an item
	if (isset($_GET['do']) && $_GET['do'] == 'edit') {
		echo '
			', $txt['shop_editing_item'], ' ', $context['shop_edit']['id'], ':
			<form action="', $scripturl, '?action=shop_items_edit;do=edit2" method="post" name="theAdminForm">
				<input type="hidden" name="id" value="', $context['shop_edit']['id'], '" />
				', $txt['shop_name'], ': <input name="itemname" type="text" value="', $context['shop_edit']['name'], '" size="80" /><br />
				', $txt['shop_description'], ': <textarea name="itemdesc" cols="40" rows="6">', $context['shop_edit']['desc'], '</textarea><br />
				', $txt['shop_price'], ': ', $modSettings['shopCurrencyPrefix'], ' <input name="itemprice" type="text" value="', $context['shop_edit']['price'], '" size="5" />', $modSettings['shopCurrencySuffix'], '<br />
				', $txt['shop_stock'], ': <input name="itemstock" type="text" value="', $context['shop_edit']['stock'], '" size="5" /><br />';
		// Output the image select box
		echoSelectImage($context['shop_edit']['image']);
		echo "<br /><input type='submit' value='{$txt['shop_edit']}' /></form>";
		
	// Deleting an item - Ask if they're sure
	} elseif (isset($_GET['do']) && $_GET['do'] == 'del') {
		echo '<form action="', $scripturl, '?action=shop_items_edit;do=del2" method="post">', 
				$txt['shop_sure_delete'], '<br />
				<ul>', $context['shop_delete_list'], '</ul>
				<input type="submit" value="', $txt['shop_delete'], '" />
				<input type="button" value="', $txt['shop_noway'], '" onclick="window.location=\'', $scripturl, '?action=shop_items_edit\'" />
			</form>
			';
		/*echo sprintf($txt['shop_sure_delete'], $context['shop_delete']), '<br />
			  <a href="', $scripturl, '?action=shop_items_edit;do=del2;id=', $context['shop_delete'], '">', $txt['shop_please_delete'], '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="', $scripturl, '?action=shop_items_edit">', $txt['shop_noway'], '</a>';*/

	// Otherwise, if they're on the main page, or they've returned from somewhere else
	// Choose item to edit or Delete
	} else {
		// If we have a message to display, display it
		// This is when they've edited or deleted an item
		if (isset($context['shop_edit_message'])) 
			echo '<span style="color: red; font-weight: bold;">', $context['shop_edit_message'], '</span><br /><br />';

		// The 'Add Item' box
		echo '
			', $txt['shop_add_item_message'], '<br />
			<form action="', $scripturl, '?action=shop_items_add;step=1" method="post">';
		// Show the list of items
		echoSelectItem();

		// The submit button, and the list of current items
		echo '<input type="submit" value="', $txt['shop_next'], '" /></form>
		', $txt['shop_edit_message'], '<br /><br />
			<form action="', $scripturl, '?action=shop_items_edit;do=del" method="post">
		', $context['shop_item_list'], '
			<input type="submit" value="', $txt['shop_delete'], '" /></form>';
	}
	// Close the table
	echo "</td></tr></table>";
}

// The restock page
function template_restock() {
	global $txt, $scripturl, $db_prefix;
	// Step 1
	if (!isset($_GET['step']) || $_GET['step'] == 1) {
		echo '
<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
	<tr valign="top" class="windowbg2">
		<td style="padding-bottom: 2ex;" width="100%">
			<div align="center"><b>', $txt['shop_admin_restock'], '</b></div>
			<form action="', $scripturl, '?action=shop_restock;step=2" method="post">
				', $txt['shop_restock_lessthan'], ': <input type="text" name="lessthan" value="5" /><br />
				', $txt['shop_restock_amount'], ': <input type="text" name="amount" value="50" /><br /><br />
				<input type="submit" value="', $txt['shop_next'], '" />
			</form>
		</td>
	</tr>
</table>';
	// Step 2 - Actually do it!
	} elseif ($_GET['step'] == 2) {		
		echo "Updated stock!";
	}
}

// Usergroup functions
function template_usergroup() {
	global $txt, $scripturl, $db_prefix, $context, $modSettings;

	if (!isset($_GET['step']) || $_GET['step'] == 1) {
		echo '
<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
	<tr valign="top" class="windowbg2">
		<td style="padding-bottom: 2ex;" width="100%">
			<div align="center"><b>'.$txt['shop_admin_usergroup'].'</b></div>
			<form action="'.$scripturl.'?action=shop_usergroup;step=2" method="post">
				'.$txt['shop_membergroup_desc'].'<br /><br />
				'.$txt['shop_membergroup'].": ".$context['shop_usergroups'].'<br />
				'.$txt['shop_action'].': <input type="radio" name="m_action" value="add" checked="checked" />'.$txt['shop_add'].' <input type="radio" name="m_action" value="sub" />'.$txt['shop_subtract'].'<br />
				'.$txt['shop_amount'].": ".$modSettings['shopCurrencyPrefix'].'<input type="text" name="value" value="0" size="10" />'.$modSettings['shopCurrencySuffix'].'<br />
				<input type="submit" value="'.$txt['shop_next'].'">
			</form>
		</td>
	</tr>
</table>';
	} elseif ($_GET['step'] == 2) {
		echo "Action completed!";
	}
}
?>
